<template>
  <div class="content">
    <vue-confirm-dialog></vue-confirm-dialog>
    <h3 class="h2" style="margin-top: 65px;">
      <i
        class="fa fa-calendar-check"
        style="padding-right: 15px; font-size: 40px"
      ></i
      ><strong>Jadwal Mata Kuliah KOTA</strong>
    </h3>
    <!-- <h3>Tabel Mata Kuliah KOTA</h3> -->
    <div
      class="main"
      style="border-radius: 20px; margin-top: 30px; min-height: 400px; box-shadow: 5px 5px #c5c5c5"
    >
      <md-table
        v-model="laporanList"
        md-sort="name"
        md-sort-order="asc"
        style="padding: 0px 10px 50px 20px; border-radius: 20px;"
      >
        <md-table-toolbar style="padding-left: 10px">
          <div class="md-toolbar-section-start">
            <md-field style="padding: 5px 0px 0px 15px; max-width: 300px;">
              <label>Pilih Periode...</label>
              <md-select
                name="periode.id"
                id="periode.id"
                v-model="selectedPeriode"
                @input="searchOnTable"
                md-dense
                style="border: 0px"
              >
                <md-option
                  v-for="(periode, key) in periodeList"
                  :key="key"
                  :value="periode.id"
                  style="width:100%; left: 10px;"
                >
                  <div
                    v-if="periode.semester == '01' || periode.semester == '1'"
                  >
                    {{ periode.tahun }} (Ganjil)
                  </div>
                  <div
                    v-if="periode.semester == '02' || periode.semester == '2'"
                  >
                    {{ periode.tahun }} (Genap)
                  </div>
                </md-option>
              </md-select>
            </md-field>
            <md-field
              style="margin-left: 30px; padding: 5px 0px 0px 15px; max-width: 300px;"
            >
              <label>Pilih Prodi...</label>
              <md-select
                name="prodi.id"
                id="prodi.id"
                v-model="selectedProdi"
                @input="searchOnTable"
                md-dense
                style="border: 0px"
              >
                <md-option
                  v-for="(prodi, key) in prodiList"
                  :key="key"
                  :value="prodi.id"
                  style="width:100%; left: 10px;"
                >
                  {{ prodi.singkatan_prodi }} - {{ prodi.nama_prodi }}
                </md-option>
              </md-select>
            </md-field>
          </div>
          <div class="container" style="padding: 0px; margin: 0px">
            <h3 class="title" style="padding-top: 30px; margin: 0px">Senin</h3>
          </div>
        </md-table-toolbar>

        <md-table-row slot="md-table-row" slot-scope="{ item }">
          <md-table-cell
            md-label=""
            md-sort-by=""
            v-if="item.jadwal.hari == 'Senin'"
            md-numeric
          >
          </md-table-cell>
          <!-- <md-table-cell md-label="Periode" md-sort-by="periode" style="width: 80px;">
            {{ item.periode.tahun }}-{{ item.periode.semester }}
          </md-table-cell> -->
          <!-- <md-table-cell
            md-label="Hari"
            md-sort-by="jadwal.hari"
            v-if="item.jadwal.hari == 'Senin'"
          >
            {{ item.jadwal.hari }}
          </md-table-cell> -->
          <md-table-cell
            md-label="Jam"
            md-sort-by="jadwal.jam"
            style="font-size: 14px"
            v-if="item.jadwal.hari == 'Senin'"
          >
            {{ item.jadwal.jam }}
          </md-table-cell>
          <md-table-cell
            md-label="Ruang"
            md-sort-by="ruangan"
            style="font-size: 14px; padding-left: 10px"
            v-if="item.jadwal.hari == 'Senin'"
          >
            {{ item.ruangan }}
          </md-table-cell>
          <md-table-cell
            md-label="Kode"
            md-sort-by="mata_kuliah.kode_mk"
            v-if="item.jadwal.hari == 'Senin'"
          >
            {{ item.mata_kuliah.kode_mk }}
          </md-table-cell>
          <md-table-cell
            md-label="Nama Mata Kuliah"
            md-sort-by="mata_kuliah.nama_mk"
            style="font-size: 14px; max-width: 300px"
            v-if="item.jadwal.hari == 'Senin'"
          >
            {{ item.mata_kuliah.nama_mk }}
          </md-table-cell>
          <!-- <md-table-cell
            md-label="Prodi"
            md-sort-by="mata_kuliah.prodi.singkatan_prodi"
            style="font-size: 14px"
            v-if="item.jadwal.hari == 'Senin'"
          >
            {{ item.mata_kuliah.prodi.singkatan_prodi }}
          </md-table-cell> -->
          <md-table-cell
            md-label="SKS"
            md-sort-by="mata_kuliah.sks_mk"
            style="padding-left: 15px"
            v-if="item.jadwal.hari == 'Senin'"
          >
            {{ item.mata_kuliah.sks_mk }}
          </md-table-cell>
          <md-table-cell
            md-label="Dosen Pengampu"
            md-sort-by="dosen.nama"
            style="font-size: 14px; max-width: 200px"
            v-if="item.jadwal.hari == 'Senin'"
          >
            {{ item.dosen.nama }}
          </md-table-cell>
          <md-table-cell v-if="item.jadwal.hari == 'Senin'">
            <router-link
              v-if="
                auth.user.level == 'admin' || auth.user.level == 'superuser'
              "
              :to="{
                name: 'report-mata-kuliah-update',
                params: { id: item.id }
              }"
            >
              <i
                class="fa fa-edit"
                aria-hidden="true"
                style="
                color: #0b76e0;
                font-size: 18px;
                padding: 0px 0px 0px 30px
              "
                ><md-tooltip md-direction="bottom"
                  >Update Daftar Mata Kuliah</md-tooltip
                ></i
              >
            </router-link>
          </md-table-cell>
          <md-table-cell v-if="item.jadwal.hari == 'Senin'">
            <md-button
              type="submit"
              class="md-simple md-button-link md-danger"
              style="height: 20px"
              @click="onDelete()"
            >
              <i
                class="fa fa-times"
                aria-hidden="true"
                style="font-size: 20px !important"
                ><md-tooltip md-direction="bottom"
                  >Delete Mata Kuliah</md-tooltip
                ></i
              >
            </md-button>
          </md-table-cell>
        </md-table-row>
      </md-table>

      <md-table
        v-model="laporanList"
        md-sort="name"
        md-sort-order="asc"
        style="padding: 0px 10px 50px 20px; border-radius: 20px;"
      >
        <md-table-toolbar style="padding-left: 10px">
          <div class="container" style="padding: 0px; margin: 0px">
            <h3 class="title" style="padding-top: 0px; margin: 0px">Rabu</h3>
          </div>
        </md-table-toolbar>

        <md-table-row slot="md-table-row" slot-scope="{ item }">
          <md-table-cell
            md-label=""
            md-sort-by=""
            v-if="item.jadwal.hari == 'Rabu'"
            md-numeric
          >
          </md-table-cell>
          <!-- <md-table-cell md-label="Periode" md-sort-by="periode" style="width: 80px;">
            {{ item.periode.tahun }}-{{ item.periode.semester }}
          </md-table-cell> -->
          <!-- <md-table-cell
            md-label="Hari"
            md-sort-by="jadwal.hari"
            style="font-size: 14px"
            v-if="item.jadwal.hari == 'Rabu'"
          >
            {{ item.jadwal.hari }}
          </md-table-cell> -->
          <md-table-cell
            md-label="Jam"
            md-sort-by="jadwal.jam"
            style="font-size: 14px"
            v-if="item.jadwal.hari == 'Rabu'"
          >
            {{ item.jadwal.jam }}
          </md-table-cell>
          <md-table-cell
            md-label="Ruang"
            md-sort-by="ruangan"
            style="font-size: 14px; padding-left: 10px"
            v-if="item.jadwal.hari == 'Rabu'"
          >
            {{ item.ruangan }}
          </md-table-cell>
          <md-table-cell
            md-label="Kode"
            md-sort-by="mata_kuliah.kode_mk"
            v-if="item.jadwal.hari == 'Rabu'"
          >
            {{ item.mata_kuliah.kode_mk }}
          </md-table-cell>
          <md-table-cell
            md-label="Nama Mata Kuliah"
            md-sort-by="mata_kuliah.nama_mk"
            style="font-size: 14px; max-width: 300px"
            v-if="item.jadwal.hari == 'Rabu'"
          >
            {{ item.mata_kuliah.nama_mk }}
          </md-table-cell>
          <!-- <md-table-cell
            md-label="Prodi"
            md-sort-by="mata_kuliah.prodi.singkatan_prodi"
            style="font-size: 14px"
            v-if="item.jadwal.hari == 'Rabu'"
          >
            {{ item.mata_kuliah.prodi.singkatan_prodi }}
          </md-table-cell> -->
          <md-table-cell
            md-label="SKS"
            md-sort-by="mata_kuliah.sks_mk"
            style="padding-left: 15px"
            v-if="item.jadwal.hari == 'Rabu'"
          >
            {{ item.mata_kuliah.sks_mk }}
          </md-table-cell>
          <md-table-cell
            md-label="Dosen Pengampu"
            md-sort-by="dosen.nama"
            style="font-size: 14px; max-width: 200px"
            v-if="item.jadwal.hari == 'Rabu'"
          >
            {{ item.dosen.nama }}
          </md-table-cell>
          <md-table-cell v-if="item.jadwal.hari == 'Rabu'">
            <router-link
              v-if="
                auth.user.level == 'admin' || auth.user.level == 'superuser'
              "
              :to="{
                name: 'report-mata-kuliah-update',
                params: { id: item.id }
              }"
            >
              <i
                class="fa fa-edit"
                aria-hidden="true"
                style="
                color: #0b76e0;
                font-size: 18px;
                padding: 0px 0px 0px 30px
              "
                ><md-tooltip md-direction="bottom"
                  >Update Mata Kuliah</md-tooltip
                ></i
              >
            </router-link>
          </md-table-cell>
          <md-table-cell v-if="item.jadwal.hari == 'Rabu'">
            <md-button
              type="submit"
              class="md-simple md-danger"
              style="height: 20px;"
              @click="onDelete2(item.id)"
            >
              <i
                class="fa fa-times"
                aria-hidden="true"
                style="font-size: 20px !important"
                ><md-tooltip md-direction="bottom"
                  >Delete Jadwal Mata Kuliah</md-tooltip
                ></i
              >
            </md-button>
          </md-table-cell>
        </md-table-row>
      </md-table>
    </div>
    <md-progress-bar md-mode="indeterminate" v-if="sending" />

    <md-snackbar :md-active.sync="userSaved"
      >Proses menghapus berhasil</md-snackbar
    >
  </div>
</template>

<script>
import { mapState, mapActions } from "vuex";
// import moment from "moment";

const toLower = text => {
  return text.toString().toLowerCase();
};

// const searchByPeriode = (items, term) => {
//   if (term) {
//     return items.filter(item =>
//       toLower(item.periode.id).includes(toLower(term))
//     );
//   }
//   return items;
// };

// const searchByProdi = (items, term) => {
//   if (term) {
//     return items.filter(item =>
//       toLower(item.mata_kuliah.prodi.id).includes(searchByPeriode(term))
//     );
//   }
//   return items;
// };

export default {
  components: {},
  bodyClass: "login-page",
  //   data() {},
  data: () => ({
    total: "",
    classicModal: false,
    search: "x",
    search1: "x",
    searched: [],
    selectedPeriode: "",
    selectedProdi: ""
  }),
  props: {
    header: {
      type: String,
      default: require("@/assets/img/gedung-upj.jpg")
    },
    image: {
      type: String,
      default: require("@/assets/img/bg-red-batik.png")
    },
    logo: {
      type: String,
      default: require("@/assets/img/logo/upj-logo.png")
    }
  },
  computed: {
    ...mapState(["auth"]),
    ...mapState("laporan", ["laporanList"]),
    ...mapState("periode", ["periodeData", "periodeList"]),
    ...mapState("prodi", ["prodiData", "prodiList"]),
    headerStyle() {
      return {
        backgroundImage: `url(${this.image})`
      };
    }
  },
  methods: {
    ...mapActions("laporan", ["getLaporanList", "deleteLaporan"]),
    ...mapActions("periode", ["getPeriode", "getPeriodeList"]),
    ...mapActions("prodi", ["getProdi", "getProdiList"]),
    async onFetchData() {
      await this.getLaporanList();
      await this.getPeriodeList();
      await this.getProdiList();
    },
    onDelete(id) {
      this.$confirm({
        message: `Yakin ingin menghapus data Jadwal Mata Kuliah?`,
        button: {
          no: "Batal",
          yes: "Ya"
        },
        /**
         * Callback Function
         * @param {Boolean} confirm
         */
        callback: confirm => {
          if (confirm) {
            try {
              this.deleteLaporan({
                id: id
              });
              window.setTimeout((this.userSaved = true), 2000);
              this.sending = false;
              this.onFetchData();
              // this.$router.push({ name: "report-mata-kuliah-kaprodi" });
            } catch (error) {
              throw Error(error);
            }
            // ... do something
          }
        }
      });
    },
    onResponsiveInverted() {
      if (window.innerWidth < 600) {
        this.responsive = true;
      } else {
        this.responsive = false;
      }
    },
    searchOnTable() {
      this.getLaporanList({
        periode_id: this.selectedPeriode,
        prodi_id: this.selectedProdi
      });
    },
    classicModalHide() {
      this.classicModal = false;
    }
  },
  async mounted() {
    this.onResponsiveInverted();
    await this.onFetchData();
    window.addEventListener("resize", this.onResponsiveInverted);
  },
  created() {
    this.searched = this.laporanList;
  }
};
</script>

<style lang="scss" scoped></style>

<style lang="css">
.gradient1 {
  background-image: linear-gradient(to bottom right, #4ac6ff, #144bb3);
}

.gradient2 {
  background-image: linear-gradient(to bottom right, #38e852, #14a82a);
}
</style>
